Object subclass:#STXInstaller
	instanceVariableNames:'stxLibDir stxBinDir installDocFiles installSourceFiles
		installSTCFiles installGoodyFiles actionPercentageHolder
		actionTextHolder commandTraceView resources'
	classVariableNames:'LastBinDir LastLibDir'
	poolDictionaries:''
	category:'eXept-tools'
!


!STXInstaller  class methodsFor:'startup'!

open
    ^ self new open

    "
     STXInstaller open
    "
! !

!STXInstaller methodsFor:'defaults'!

defaultBinDirs
    |dirs|

    dirs := OrderedCollection new.
    dirs add:'/usr/local/bin'.
    dirs add:'/usr/bin'.
    dirs add:(Filename homeDirectory constructString:'bin').
    dirs add:((Filename homeDirectory 
			    construct:'stx')
			    constructString:'bin').
    dirs add:'/tmp/stxbin'.
    ('/home' asFilename exists and:['/home' asFilename isDirectory]) ifTrue:[
        dirs add:'/home/stx/bin'.
    ].
    ('/home2' asFilename exists and:['/home2' asFilename isDirectory]) ifTrue:[
        dirs add:'/home2/stx/bin'.
    ].

"/    dirs := dirs select:[:path | 
"/                            |f|
"/
"/                            f := path asFilename.
"/                            f exists and:[f isDirectory]].
    ^ dirs sort

    "Created: 18.7.1996 / 19:43:00 / cg"
    "Modified: 18.7.1996 / 19:45:08 / cg"
!

defaultLibDirs
    |dirs|

    dirs := OrderedCollection new.
    dirs add:'/usr/local/lib/smalltalk'.
    dirs add:'/usr/lib/smalltalk'.
    dirs add:((Filename homeDirectory 
                            construct:'lib')
                            constructString:'smalltalk').
    dirs add:((Filename homeDirectory 
                            construct:'stx')
                            constructString:'lib').
    dirs add:'/tmp/stxlib'.
    dirs add:'/home/stx/lib'.
    dirs add:'/home2/stx/lib'.

"/    dirs := dirs select:[:path | 
"/                            |f|
"/
"/                            f := path asFilename.
"/                            f exists and:[f isDirectory]].
    ^ dirs sort

    "Created: 18.7.1996 / 19:43:21 / cg"
    "Modified: 18.7.1996 / 19:46:04 / cg"
!

directoriesToMake
    |dirsToMake|

    dirsToMake := OrderedCollection new.
    dirsToMake add:stxBinDir.
    dirsToMake add:stxLibDir.
    dirsToMake add:(stxLibDir asFilename constructString:'lib').
    dirsToMake add:(stxLibDir asFilename constructString:'doc').
    dirsToMake add:(stxLibDir asFilename constructString:'doc/online').
    dirsToMake add:(stxLibDir asFilename constructString:'doc/online/english').
    dirsToMake add:(stxLibDir asFilename constructString:'doc/online/german').
    dirsToMake add:(stxLibDir asFilename constructString:'include').
    dirsToMake add:(stxLibDir asFilename constructString:'resources').
    dirsToMake add:(stxLibDir asFilename constructString:'binary').
    dirsToMake add:(stxLibDir asFilename constructString:'bitmaps').
    dirsToMake add:(stxLibDir asFilename constructString:'goodies').

    ^ dirsToMake
!

specOfFilesToCopy
    |fileSpec|

    fileSpec := #(
                "/ name                               destination   subDir               required mode      
                ( 'projects/smalltalk/smalltalk'        #bin     nil                  true  '755' )
                ( 'projects/smalltalk/include'          #lib     nil                  true  '644' )
                ( 'projects/smalltalk/*.rc'             #lib     nil                  true  '644' )
                ( 'projects/smalltalk/patches'          #lib     nil                  true  '644' )
                ( 'projects/smalltalk/bitmaps'          #lib     nil                  true  '644' )
                ( 'projects/smalltalk/resources'        #lib     nil                  true  '644' )
                ( 'projects/smalltalk/lib'              #lib     nil                  true  '644' )
                ( 'doc/online/german/LICENSE.STX.html'  #lib     'doc/online/german'  true  '644' )
                ( 'doc/online/english/LICENSE.STX.html' #lib     'doc/online/english' true  '644' )
    ).

    installDocFiles ifTrue:[
        fileSpec := fileSpec , #(
                ( 'doc'                              #lib     nil        false '644' )
        ).
    ].

    installSourceFiles ifTrue:[
        fileSpec := fileSpec , #(
                ( 'projects/smalltalk/source'                #lib     nil        false '644' )
        ).
    ].

    installSTCFiles ifTrue:[
        fileSpec := fileSpec , #(
                ( 'stc/stc'                                  #bin     nil        false '755' )
                ( 'rules/stmkmp'                             #bin     nil        false '755' )
                ( 'rules/stmkmf'                             #bin     nil        false '755' )
                ( 'include'                                  #lib     nil        false '644' )
                ( 'configurations'                           #lib     nil        false '644' )
                ( 'rules'                                    #lib     nil        false '644' )

                ( 'support/VGL/vogl/src/libvogl.*'           #lib     'lib'      false '644' )
                ( 'support/VGL/vogl/src/*.h'                 #lib     'include'  false '644' )
                ( 'support/DLD/dld-3.2.5/libdld.*'           #lib     'lib'      false '644' )
                ( 'goodies/persistency/db-1.6/PORT/libdb.*'  #lib     'lib'      false '644' )

                ( 'librun/librun.*'                          #lib     'lib'      false '644' )
                ( 'libbasic/libbasic.*'                      #lib     'lib'      false '644' )
                ( 'libbasic2/libbasic2.*'                    #lib     'lib'      false '644' )
                ( 'libbasic3/libbasic3.*'                    #lib     'lib'      false '644' )
                ( 'libcomp/libcomp.*'                        #lib     'lib'      false '644' )
                ( 'libview/libview.*'                        #lib     'lib'      false '644' )
                ( 'libview2/libview2.*'                      #lib     'lib'      false '644' )
                ( 'libwidg/libwidg.*'                        #lib     'lib'      false '644' )
                ( 'libwidg2/libwidg2.*'                      #lib     'lib'      false '644' )
                ( 'libwidg3/libwidg3.*'                      #lib     'lib'      false '644' )
                ( 'libsnmp/libsnmp.*'                        #lib     'lib'      false '644' )
                ( 'contrib/libPVM/libPVM.*'                  #lib     'lib'      false '644' )
                ( 'goodies/persistency/libdbase.*'           #lib     'lib'      false '644' )
                ( 'libtable/libtable.*'                      #lib     'lib'      false '644' )
                ( 'libtool/libtool.*'                        #lib     'lib'      false '644' )
                ( 'libxt/libxt.*'                            #lib     'lib'      false '644' )
                ( 'librt/librt.*'                            #lib     'lib'      false '644' )
        ).
    ].

    installGoodyFiles ifTrue:[
        fileSpec := fileSpec , #(
                ( 'goodies/*.st'                             #lib     'goodies'  false '644' )
                ( 'goodies/*.chg'                            #lib     'goodies'  false '644' )
                ( 'goodies/rdoit/rdoit'                      #bin     nil        false '755' )
        ).
    ].


    ^ fileSpec

! !

!STXInstaller methodsFor:'installing'!

copyFiles
    |msg fileSpec filesToCopy numFiles nDone|

    msg := (resources array:#('ST/X Installation' '' 'copying:' '' 'to:' '')) asStringCollection.

    fileSpec := self specOfFilesToCopy.

    filesToCopy := OrderedCollection new.

    fileSpec do:[:entry |
        |fileNames dest subDir required destDir|

        fileNames := entry at:1.
        dest := entry at:2.
        subDir := entry at:3.
        required := entry at:4.

        dest == #bin ifTrue:[
            destDir := stxBinDir
        ] ifFalse:[
            destDir := stxLibDir
        ].
        
        destDir := destDir asFilename.
        subDir notNil ifTrue:[
            destDir := destDir construct:subDir
        ].

        filesToCopy add:(fileNames -> destDir pathName)
    ].

    numFiles := filesToCopy size.
    nDone := 0.

    filesToCopy do:[:entry |
        |fileName destDir cmd p text line doneSemaphore|

        fileName := entry key.
        destDir := entry value.

        ((fileName includes:$*)
        or:[('../../' , fileName) asFilename exists])ifTrue:[
            actionPercentageHolder value:(nDone / numFiles * 100) rounded.

            msg at:4 put:'    ' , (fileName asText allBold).
            msg at:6 put:'    ' , (destDir asText allBold).
            actionTextHolder value:nil.
            actionTextHolder value:msg.

            cmd := 'cp -r ../../' , fileName , ' ' , destDir.
            commandTraceView showCR:cmd , ' ...'.
            cmd := 'sh -c "echo ; ' , cmd , ' 2>&1"' .

            doneSemaphore := Semaphore new.

            [   

                p := PipeStream readingFrom:cmd.
                p isNil ifTrue:[
                    self warn:('command error. Could not execute:\\' , cmd) withCRs.
                ] ifFalse:[
                    [p atEnd] whileFalse:[
                        [p readWaitWithTimeout:0.1] whileTrue:[].
                        line := p nextLine.
                        (line notNil and:[line notEmpty]) ifTrue:[
                            commandTraceView showCR:(('  ' , line) asText emphasizeAllWith:(#color->Color red)).
                        ]
                    ].
                    p close.
                ].
                doneSemaphore signal.
            ] forkAt:4.

            doneSemaphore wait.

        ].

        nDone := nDone + 1
    ].

    ^ true

    "Created: 17.7.1996 / 15:16:20 / cg"
    "Modified: 18.7.1996 / 22:20:24 / cg"
!

createDirectories
    |msg dirsToMake numDirs nDone|

    msg := (resources array:#('ST/X Installation' '' 'creating directory:' '' '' '')) asStringCollection.

    dirsToMake := self directoriesToMake.

    numDirs := dirsToMake size.
    nDone := 0.

    dirsToMake do:[:dirName |
        |d errMsg stop box|

        actionPercentageHolder value:(nDone / numDirs * 100) rounded.

        msg at:4 put:'    ' , (dirName asText allBold).
        actionTextHolder value:nil.
        actionTextHolder value:msg.

        d := dirName asFilename.

        commandTraceView showCR:(resources string:'creating %1 ...' with:d pathName).

        d exists ifFalse:[
            OperatingSystem recursiveCreateDirectory:d pathName
        ].

        d exists ifFalse:[
            errMsg := resources string:'failed to create directory: %1' with: dirName.
            stop := true
        ] ifTrue:[
            d isDirectory ifFalse:[
                errMsg := resources string:'not a directory: %1' with:dirName.
                stop := true
            ] ifTrue:[
                (d isReadable
                and:[d isWritable]) ifFalse:[
                    errMsg := resources string:'no read/write access to directory: %1' with:dirName.
                    stop := false
                ] ifTrue:[
                    errMsg := nil
                ]
            ]
        ].

        errMsg notNil ifTrue:[
            box := WarningBox new.
            box title:errMsg.
            box showAtPointerNotCovering:(WindowGroup activeGroup topViews first).
            stop ifTrue:[^ false].
        ].

        Delay waitForSeconds:0.25.
        nDone := nDone + 1.
    ].
    ^ true

    "Created: 17.7.1996 / 15:24:19 / cg"
    "Modified: 18.7.1996 / 22:18:38 / cg"
! !

!STXInstaller methodsFor:'startup'!

askAndInstall
    "/ check, if we are in the projects/smalltalk directory

    resources := ResourcePack for:self class.

    (Filename currentDirectory pathName endsWith:'projects/smalltalk') ifFalse:[
        self warn:(resources string:'must be in the ''projects/smalltalk'' directory').
        ^ self
    ].

    [self askForDestination] whileTrue:[
        self checkForExistingInstallationAndConfirm ifFalse:[
            ^ self
        ].
        self doInstall ifTrue:[
            self postInstall.
            ^ self
        ].
        (self confirm:(resources string:'installation failed or aborted - retry ?'))
        ifFalse:[
            ^ self
        ]
    ].

    "Modified: 18.7.1996 / 21:20:56 / cg"
!

askForDestination
    "open a dialog to enter destination directories"

    |d cm l green dark img
     stxLibDirHolder stxBinDirHolder
     installDocHolder installSourceHolder installSTCHolder installGoodiesHolder
     binMegabytes libMegabytes
    |

    binMegabytes := 10.
    libMegabytes := 10.

    LastLibDir isNil ifTrue:[
        LastLibDir := '/usr/local/lib/smalltalk'
    ].
    LastBinDir isNil ifTrue:[
        LastBinDir := '/usr/local/bin'
    ].

    stxLibDirHolder := LastLibDir asValue.
    stxBinDirHolder := LastBinDir asValue.
    installDocHolder := true asValue.
    installSourceHolder := true asValue.
    installSTCHolder := true asValue.
    installGoodiesHolder := true asValue.

    Screen current hasColors ifTrue:[
        green := (Color red:0 green:80 blue:20) "darkened".
        dark := Color grey:10.
    ] ifFalse:[
        green := Color white.
        dark := Color black.
    ].

    d := DialogBox new.

    d label:(resources string:'ST/X CD Installation').
    img := Image fromFile:'SmalltalkX.xbm'.

    l := d addTextLabel:img.
    l adjust:#left; foregroundColor:green backgroundColor:dark.

    l := d addTextLabel:(resources string:'Smalltalk/X CD installation.').
    l adjust:#left; backgroundColor:dark; foregroundColor:Color white.
    d addVerticalSpace.
    d addVerticalSpace.

    d addHorizontalLine.

    l := d addTextLabel:(resources string:'Destination directories:').
    l adjust:#left; backgroundColor:dark; foregroundColor:Color white.

    cm := ComboBoxView on:stxBinDirHolder.
    cm list:self defaultBinDirs.
    d 
        addLabelledField:cm 
        label:(resources string:'binaries')
        adjust:#left 
        tabable:true 
        from:0.0 to:1.0 separateAtX:0.25
        nameAs:'binaryBox'.

    (d componentAt:'binaryBox.label') backgroundColor:dark; foregroundColor:Color white.

    cm := ComboBoxView on:stxLibDirHolder.
    cm list:self defaultLibDirs.
    d 
        addLabelledField:cm 
        label:(resources string:'libraries') 
        adjust:#left 
        tabable:true 
        from:0.0 to:1.0 separateAtX:0.25
        nameAs:'libraryBox'.

    (d componentAt:'libraryBox.label') backgroundColor:dark; foregroundColor:Color white.

    d addVerticalSpace.
    d addHorizontalLine.
    d addVerticalSpace.

    (d addTextLabel:(resources string:'required:'))
        adjust:#left; foregroundColor:Color white backgroundColor:dark.

    d leftIndent:35.
    (d addTextLabel:(resources string:'binaries (approx. %1 Mb)' with:binMegabytes printString))
        adjust:#left; foregroundColor:Color white backgroundColor:dark.
    (d addTextLabel:(resources string:'libraries (approx. %1 Mb)' with:libMegabytes printString))
        adjust:#left; foregroundColor:Color white backgroundColor:dark.
    d leftIndent:0.

    d addVerticalSpace.
    d addHorizontalLine.
    d addVerticalSpace.

    (d addTextLabel:(resources string:'optional:'))
        adjust:#left; foregroundColor:Color white backgroundColor:dark.

    (d addCheckBox:((resources string:'doc files') , ' (+8 Mb)') on:installDocHolder)
        labelView foregroundColor:Color white backgroundColor:dark.
    (d addCheckBox:((resources string:'stc & support files') , ' (+2 Mb)') on:installSTCHolder)
        labelView foregroundColor:Color white backgroundColor:dark.

    d addVerticalSpace.
    d addHorizontalLine.
    d addVerticalSpace.

    (d addTextLabel:(resources string:'optional (but highly recommended):'))
        adjust:#left; foregroundColor:Color white backgroundColor:dark.

    (d addCheckBox:((resources string:'smalltalk source files') , ' (+12 Mb)') on:installSourceHolder)
        labelView foregroundColor:Color white backgroundColor:dark.
    (d addCheckBox:((resources string:'goodies') , ' (+0.5 Mb)') on:installGoodiesHolder)
        labelView foregroundColor:Color white backgroundColor:dark.

    d addVerticalSpace.
    d addHorizontalLine.

    d addAbortButton; addOkButtonLabelled:(resources string:'install').
    d extent:400@300.

    d allViewBackground:dark.

    d openAtCenter.
    d accepted ifTrue:[
        stxLibDir := LastLibDir := stxLibDirHolder value.
        stxBinDir := LastBinDir := stxBinDirHolder value.
        installDocFiles := installDocHolder value.
        installSourceFiles := installSourceHolder value.
        installSTCFiles := installSTCHolder value.
        installGoodyFiles := installGoodiesHolder value.
        d destroy.
        ^ true
    ].
    d destroy.
    ^ false

    "Modified: 18.7.1996 / 19:43:38 / cg"
!

checkForExistingInstallationAndConfirm
    "look if there is another installation and confirm
     reinstalling; return true if ok, false if not"

    |whatToDo|

    stxLibDir asFilename exists ifTrue:[
        whatToDo := Dialog 
                        choose:(resources 
                                    string:'detected existing ST/X installation in %1' 
                                      with:stxLibDir asText allBold)
                        label:(resources string:'Attention')
                        labels:(resources array:#('remove first' 'overwrite' 'cancel')) 
                        values:#(remove over nil) 
                        default:nil.     
        whatToDo isNil ifTrue:[^false].
        whatToDo == #remove ifTrue:[
            (OperatingSystem recursiveRemoveDirectory:stxLibDir)
            ifFalse:[
                self warn:(resources string:'mhmh - could not remove old installation.')
            ].
        ].
        ^ true
"/        ^ DialogBox
"/            confirm:('detected existing installation in ' 
"/                     , stxLibDir asText allBold
"/                     , '\\continue & overwrite ?') withCRs 
"/           yesLabel:'overwrite' noLabel:'cancel'
        
    ].
    ^ true

    "Modified: 18.7.1996 / 20:01:36 / cg"
!

doInstall
    "install ST/X; return true if ok, false if not"

    |progressView ok textView|

    textView := HVScrollableView for:TextCollector.
    textView preferredExtent:(100 @ 250).
    commandTraceView := textView scrolledView.

    progressView := ProgressIndicator
                        inBoxWithLabel:'ST/X Installation' icon:(Depth8Image fromImage:NewLauncher aboutIcon)
                        text:#('ST/X Installation' '' '' '' '' '' '' '') asStringCollection
                        abortable:true
                        view:textView
                        closeWhenDone:false.
    progressView topView extent:(500 min:Display width) @ 300.

    ok := false.

    progressView showProgressOf:
            [:progressValue :currentAction| |msg|

              Processor activeProcess withPriority:7 do:[
                  actionPercentageHolder := progressValue.
                  actionTextHolder := currentAction.

                  (self createDirectories) ifTrue:[
                      ok := self copyFiles
                  ].
                  progressValue value:100.

                  progressView topView abortButton label:(resources string:'continue').
                  progressView topView abortButton action:[progressView topView hide].
                  msg := (resources 
                             array:#('ST/X Installation finished.' '' 'press continue ...' '' '' ''))
                                 asStringCollection.
                  actionTextHolder value:nil.
                  actionTextHolder value:msg.
              ] 
            ].

    ^ ok

    "Created: 17.7.1996 / 15:11:27 / cg"
    "Modified: 17.7.1996 / 15:24:27 / cg"
!

open
    self askAndInstall.

    "
     STXInstaller open
    "
!

postInstall
    "some messages at the end ..."

    |shInfo cshInfo msg havePath|

    msg := (resources string:'ST/X Installation complete.\\') withCRs.
    shInfo := ''.
    cshInfo := ''.

    havePath := true.
    (((OperatingSystem getEnvironment:'PATH')
        asCollectionOfSubstringsSeparatedBy:$:)
            includes:stxBinDir) ifFalse:[

        havePath := false.
        shInfo  := 'PATH=$PATH:' , stxBinDir , ' ; export PATH\'.
        cshInfo := 'set path=($path ' , stxBinDir , ')\'.
        msg := msg , (resources string:'%1 is not in your PATH.\You should change your ".login" and/or ".profile" files to include it.\\'
                                  with:stxBinDir asText allBold) withCRs.
    ].

    (stxLibDir ~= '/usr/local/lib/smalltalk'
    and:[stxLibDir ~= '/usr/lib/smalltalk']) ifTrue:[
        msg := msg , (resources string:'The library directory is not a standard ST/X library directory\("/usr/local/lib/smalltalk" or "/usr/lib/smalltalk").\You have to define the %1 environment variable\as %2 before ST/X can be started.\'
                                  with:'STX_LIBDIR' asText allBold 
                                  with:stxLibDir asText allBold) withCRs.
        havePath ifFalse:[
            msg := msg , (resources string:'The above mentioned files are also a good place to do this.\') withCRs.
        ] ifTrue:[
            msg := msg , (resources string:'The ".login" and/or ".profile" files are a good place to do this.\') withCRs.
        ].

        shInfo := shInfo , 'STX_LIBDIR=' , stxLibDir , ' ; export STX_LIBDIR\'.
        cshInfo := cshInfo , 'setenv STX_LIBDIR ' , stxLibDir , '\'.
    ].

    shInfo notEmpty ifTrue:[
        '*********************************************************' errorPrintCR.
        (resources string:'Message from the ST/X Installer:\\') withCRs errorPrintCR.
        (resources string:'Please add the following to your ".profile" file:') withCRs errorPrintCR.
        '' errorPrintCR.
        shInfo withCRs errorPrintCR.
        '' errorPrintCR.
        (resources string:'or (if you use csh/tcsh), add to your ".login" file:') withCRs errorPrintCR.
        '' errorPrintCR.
        cshInfo withCRs errorPrintCR.
        '' errorPrintCR.
        '*********************************************************' errorPrintCR.
    ].
    self information:msg.

    "
     STXInstaller new postInstall
    "

    "Modified: 18.7.1996 / 22:10:42 / cg"
! !

!STXInstaller  class methodsFor:'documentation'!

version
    ^ '$Header$'
! !
